import { world } from '@minecraft/server';
world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry: blockReg }) => {
    blockReg.registerCustomComponent('md:acoustic_horizontal_place', {
        onPlace(e) {
           const { block } = e;
           const tag = block.getTags().find(mono => mono == 'acoustic_horizontal');
           const direction = block.permutation.getState('minecraft:cardinal_direction');
           let front
           let frontRight
           let frontLeft
           let right
           let left
           let rights
           let lefts
           if (direction == 'north') {
             front = block.south();
             frontRight = front.east();
             frontLeft = front.west();
             right = block.north().east();
             left = block.north().west();
             rights = block.east();
             lefts = block.west();
           } else if (direction == 'south') {
             front = block.north();
             frontRight = front.west();
             frontLeft = front.east();
             right = block.south().west();
             left = block.south().east();
             rights = block.west();
             lefts = block.east();
           } else if (direction == 'west') {
             front = block.east();
             frontRight = front.north();
             frontLeft = front.south();
             right = block.west().north();
             left = block.west().south();
             rights = block.north();
             lefts = block.south();
           } else {
             front = block.west();
             frontRight = front.south();
             frontLeft = front.north();
             right = block.east().south();
             left = block.east().north();
             rights = block.south();
             lefts = block.north();
           }
           const frontDir = front.permutation.getState('minecraft:cardinal_direction');
           const frontRightDir = frontRight.permutation.getState('minecraft:cardinal_direction');
           const frontLeftDir = frontLeft.permutation.getState('minecraft:cardinal_direction');
           const rightDir = right.permutation.getState('minecraft:cardinal_direction');
           const leftDir = left.permutation.getState('minecraft:cardinal_direction');
           const rightsDir = rights.permutation.getState('minecraft:cardinal_direction');
           const leftsDir = lefts.permutation.getState('minecraft:cardinal_direction');
           let frontValid
           let rightValid = false;
           let leftValid = false;
           let rightsValid = false;
           let leftsValid = false;
           if (direction == 'north') {
             if (frontDir == 'west') {
               frontValid = 'left';
             } else if (frontDir == 'east') {
               frontValid = 'right';
             }
             if (rightDir == 'west') rightValid = true;
             if (leftDir == 'east') leftValid = true;
             if (rightsDir == 'east') rightsValid = true;
             if (leftsDir == 'west') leftsValid = true;
           } else if (direction == 'south') {
             if (frontDir == 'east') {
               frontValid = 'left';
             } else if (frontDir == 'west') {
               frontValid = 'right';
             }
             if (rightDir == 'east') rightValid = true;
             if (leftDir == 'west') leftValid = true;
             if (rightsDir == 'west') rightsValid = true;
             if (leftsDir == 'east') leftsValid = true;
           } else if (direction == 'west') {
             if (frontDir == 'south') {
               frontValid = 'left';
             } else if (frontDir == 'north') {
               frontValid = 'right';
             }
             if (rightDir == 'south') rightValid = true;
             if (leftDir == 'north') leftValid = true;
             if (rightsDir == 'north') rightsValid = true;
             if (leftsDir == 'south') leftsValid = true;
           } else {
             if (frontDir == 'north') {
               frontValid = 'left';
             } else if (frontDir == 'south') {
               frontValid = 'right';
             }
             if (rightDir == 'north') rightValid = true;
             if (leftDir == 'south') leftValid = true;
             if (rightsDir == 'south') rightsValid = true;
             if (leftsDir == 'north') leftsValid = true;
           }
           let backRightValid = false;
           let backLeftValid = false;
           let frontRightValid = false;
           let frontLeftValid = false;
           if (rightDir == direction) backRightValid = true;
           if (leftDir == direction) backLeftValid = true;
           if (frontRightDir == direction) frontRightValid = true;
           if (frontLeftDir == direction) frontLeftValid = true;
           const Right = right.hasTag(tag);
           const Left = left.hasTag(tag);
           if (Right && rightValid) block.setPermutation(block.permutation.withState('md:out', true));
           let Out = left.permutation.getState('md:out');
           if (Left && leftValid && !Out) left.setPermutation(left.permutation.withState('md:out', true));
           let inLeft = right.permutation.getState('md:in_left');
           if (Right && backRightValid && !inLeft) {
             block.setPermutation(block.permutation.withState('md:out', true));
             right.setPermutation(right.permutation.withState('md:in_left', true));
           }
           let inRight = left.permutation.getState('md:in_right');
           Out = left.permutation.getState('md:out');
           if (Left && backLeftValid && !inRight && !Out) {
             left.setPermutation(left.permutation.withState('md:out', true));
             left.setPermutation(left.permutation.withState('md:in_right', true));
           }
           const Rights = rights.hasTag(tag);
           const Lefts = lefts.hasTag(tag);
           inLeft = rights.permutation.getState('md:in_left');
           if (Rights && rightsValid && !inLeft) rights.setPermutation(rights.permutation.withState('md:in_left', true));
           inRight = lefts.permutation.getState('md:in_right');
           Out = lefts.permutation.getState('md:out');
           if (Lefts && leftsValid && !inRight && !Out) lefts.setPermutation(lefts.permutation.withState('md:in_right', true));
           const Front = front.hasTag(tag);
           const FrontRight = frontRight.hasTag(tag);
           const FrontLeft = frontLeft.hasTag(tag);
           if (Front && ((frontValid == 'right' && !rightValid && !rightsValid && !backRightValid) || (frontValid == 'left' && !leftValid && !leftsValid  && !backLeftValid))) block.setPermutation(block.permutation.withState('md:in_' + frontValid, true));
           if (FrontRight && frontRightValid && ((Front && frontValid) || !Front)) {
             block.setPermutation(block.permutation.withState('md:out', true));
             block.setPermutation(block.permutation.withState('md:in_right', true));
           }
           if (FrontLeft && frontLeftValid && ((Front && frontValid) || !Front)) {
             frontLeft.setPermutation(frontLeft.permutation.withState('md:out', true));
             block.setPermutation(block.permutation.withState('md:in_left', true));
           }
        }
    });
    blockReg.registerCustomComponent('md:acoustic_horizontal_break', {
        onPlayerDestroy(e) {
           const { destroyedBlockPermutation: Block, block } = e;
           const tag = Block.getTags().find(deco => deco == 'acoustic_horizontal');
           const direction = Block.getState('minecraft:cardinal_direction');
           let frontLeft
           let right
           let back
           let left
           let rights
           let lefts
           if (direction == 'north') {
             frontLeft = block.south().west();
             back = block.north();
             right = back.east();
             left = back.west();
             rights = block.east();
             lefts = block.west();
           } else if (direction == 'south') {
             frontLeft = block.north().east();
             back = block.south();
             right = back.west();
             left = back.east();
             rights = block.west();
             lefts = block.east();
           } else if (direction == 'west') {
             frontLeft = block.east().south();
             back = block.west();
             right = back.north();
             left = back.south();
             rights = block.north();
             lefts = block.south();
          } else {
             frontLeft = block.west().north();
             back = block.east();
             right = back.south();
             left = back.north();
             rights = block.south();
             lefts = block.north();
          }
           const backDir = back.permutation.getState('minecraft:cardinal_direction');
           const rightDir = right.permutation.getState('minecraft:cardinal_direction');
           const leftDir = left.permutation.getState('minecraft:cardinal_direction');
           const rightsDir = rights.permutation.getState('minecraft:cardinal_direction');
           const leftsDir = lefts.permutation.getState('minecraft:cardinal_direction');
           const frontLeftDir = frontLeft.permutation.getState('minecraft:cardinal_direction');
           let backValid = false;
           let leftValid = false;
           let rightsValid = false;
           let leftsValid = false;
           if (direction == 'north') {
             if (backDir == 'east') backValid = true;
             if (leftDir == 'east') leftValid = true;
             if (rightsDir == 'east') rightsValid = true;
             if (leftsDir == 'west') leftsValid = true;
           } else if (direction == 'south') {
             if (backDir == 'west') backValid = true;
             if (leftDir == 'west') leftValid = true;
             if (rightsDir == 'west') rightsValid = true;
             if (leftsDir == 'east') leftsValid = true;
           } else if (direction == 'west') {
             if (backDir == 'north') backValid = true;
             if (leftDir == 'north') leftValid = true;
             if (rightsDir == 'north') rightsValid = true;
             if (leftsDir == 'south') leftsValid = true;
          } else {
             if (backDir == 'south') backValid = true;
             if (leftDir == 'south') leftValid = true;
             if (rightsDir == 'south') rightsValid = true;
             if (leftsDir == 'north') leftsValid = true;
          }
           let backRightValid = false;
           let backLeftValid = false;
           let frontLeftValid = false;
           if (rightDir == direction) backRightValid = true;
           if (leftDir == direction) backLeftValid = true;
           if (frontLeftDir == direction) frontLeftValid = true;
           const Right = right.hasTag(tag);
           const Left = left.hasTag(tag);
           let Out = left.permutation.getState('md:out');
           if (Left && leftValid && Out) left.setPermutation(left.permutation.withState('md:out', false));
           if (Right && backRightValid) right.setPermutation(right.permutation.withState('md:in_left', false));
           const inRight = left.permutation.getState('md:in_right');
           if (Left && backLeftValid && inRight && Out) {
             left.setPermutation(left.permutation.withState('md:out', false));
             left.setPermutation(left.permutation.withState('md:in_right', false));
           }
           const Rights = rights.hasTag(tag);
           const Lefts = lefts.hasTag(tag);
           const Back = back.hasTag(tag);
           Out = back.permutation.getState('md:out');
           if (Rights && rightsValid && ((Back && ((backValid && !Out) || (!backValid && Out))) || !Back)) rights.setPermutation(rights.permutation.withState('md:in_left', false));
           Out = lefts.permutation.getState('md:out');
           if (Lefts && leftsValid && !Out) lefts.setPermutation(lefts.permutation.withState('md:in_right', false));
           const FrontLeft = frontLeft.hasTag(tag);
           if (FrontLeft && frontLeftValid) frontLeft.setPermutation(frontLeft.permutation.withState('md:out', false));
        }
    });
});