import { world, system } from '@minecraft/server';
import { ActionFormData } from '@minecraft/server-ui';
import { Sit, Lay, Bocil, Ride, Clear } from './fungsi.js';

world.beforeEvents.itemUse.subscribe(mono => {
    const { source: player, itemStack: item } = mono;
    if (!item || item.typeId.split(':')[1] != 'monophone') return;
    mono.cancel = true;
    const isLay = player.getProperty('md:sleep');
    const lay = isLay ? 'Aktif' : 'Nonaktif';
    const isRide = player.getProperty('md:ride');
    const ride = isRide ? 'Aktif' : 'Nonaktif';
    const isBocil = player.hasComponent('is_baby');
    const bocil = isBocil ? 'Aktif' : 'Nonaktif';
    system.run(() => {
      new ActionFormData().title('Command')
      .body('')
      .button('Sit')
      .button('Lay\n' + lay)
      .button('Ride\n' + ride)
      .button('Bocil\n' + bocil)
      .button('Clear Inventory')
      .show(player).then(r => {
        if (r.canceled) return;
        switch (r.selection) {
          case 0:
            Sit(player);
            break;
          case 1:
            Lay(player, isLay);
            break;
          case 2:
            Ride(player, isRide);
            break;
          case 3:
            Bocil(player, isBocil);
            break;
          case 4:
            Clear(player);
            break;
          default: break;
        }
      });
    });
});