import { world, BlockPermutation, system } from '@minecraft/server';
world.beforeEvents.worldInitialize.subscribe(mono => {
  mono.blockComponentRegistry.registerCustomComponent('md:door_place', {
    onPlace(e) {
      const { block } = e;
      // Pastikan block bukan air sebelum mengubah state
      if (block.typeId === 'minecraft:air') return;
      block.setPermutation(block.permutation.withState('md:placed', true));
      const bawah = block.below();
      const doorType = block.permutation.getState('md:door_type');
      const bawahType = bawah.permutation.getState('md:door_type');
      if (bawahType != 'bottom' && bawahType != 'middle') {
        block.setPermutation(block.permutation.withState('md:door_type', 'bottom'));
      }
      const doorTypes = block.permutation.getState('md:door_type');
      const atas = block.above();
      const tipe = block.typeId;
      if (doorTypes == 'bottom' && !atas.isAir) {
        block.setType('minecraft:air');
        return;
      }
      const direction = block.permutation.getState('minecraft:cardinal_direction');
      if (doorTypes == 'bottom' && atas.isAir) {
        atas.setType(tipe);
        atas.setPermutation(atas.permutation.withState('minecraft:cardinal_direction', direction));
      }
      const selatan = block.south();
      const utara = block.north();
      const barat = block.west();
      const timur = block.east();
      const sideDir = direction === 'north' ? barat.permutation.getState('minecraft:cardinal_direction') : direction === 'south' ? timur.permutation.getState('minecraft:cardinal_direction') : direction === 'west' ? selatan.permutation.getState('minecraft:cardinal_direction') : utara.permutation.getState('minecraft:cardinal_direction');
      const sideIsMirror = direction === 'north' ? barat.permutation.getState('md:mirror') : direction === 'south' ? timur.permutation.getState('md:mirror') : direction === 'west' ? selatan.permutation.getState('md:mirror') : utara.permutation.getState('md:mirror');
      if ((direction === 'north' && barat.typeId === tipe && sideDir === 'north' && !sideIsMirror) || (direction === 'south' && timur.typeId === tipe && sideDir === 'south' && !sideIsMirror) || (direction === 'west' && selatan.typeId === tipe && sideDir === 'west' && !sideIsMirror) || (direction === 'east' && utara.typeId === tipe && sideDir === 'east' && !sideIsMirror)) {
        block.setPermutation(block.permutation.withState('md:mirror', true));
        const sideMid = direction === 'north' ? barat.permutation.getState('md:door_type') == 'middle' : direction === 'south' ? timur.permutation.getState('md:door_type') == 'middle' : direction === 'west' ? selatan.permutation.getState('md:door_type') == 'middle' : utara.permutation.getState('md:door_type') == 'middle';
        if (sideMid) {
          atas.setType(tipe);
          atas.setPermutation(atas.permutation.withState('minecraft:cardinal_direction', direction));
          block.setPermutation(block.permutation.withState('md:door_type', 'middle'));
          bawah.setPermutation(bawah.permutation.withState('md:door_type', 'bottom_2'));
        }
        const isOpen = direction === 'north' ? barat.permutation.getState('md:is_open') : direction === 'south' ? timur.permutation.getState('md:is_open') : direction === 'west' ? selatan.permutation.getState('md:is_open') : utara.permutation.getState('md:is_open');
        block.setPermutation(block.permutation.withState('md:is_open', isOpen));
        if (!block.hasTag('door_slide')) return;
        const sideOpen = direction === 'north' ? barat.permutation.getState('md:open') : direction === 'south' ? timur.permutation.getState('md:open') : direction === 'west' ? selatan.permutation.getState('md:open') : utara.permutation.getState('md:open');
        if (sideOpen > 0) {
          block.setPermutation(block.permutation.withState('md:open', sideOpen));
          if (sideOpen < 4) {
            block.setPermutation(block.permutation.withState('md:tick', true));
          }
        }
      }
    }
  });
  mono.blockComponentRegistry.registerCustomComponent('md:door_destroy', {
    onPlayerDestroy(e) {
      const { block } = e;
      const selatan = block.south();
      const utara = block.north();
      const barat = block.west();
      const timur = block.east();
      const bawah = block.below();
      const atas = block.above();
      const isTopBlock = bawah.permutation.getState('md:door_type') == 'bottom' || bawah.permutation.getState('md:door_type') == 'bottom_2';
      const isTopsBlock = bawah.permutation.getState('md:door_type') == 'middle';
      const targetBlock = (isTopsBlock || isTopBlock) ? block.below() : block.above();
      const targetId = targetBlock.typeId;
      targetBlock.setType('minecraft:air');
      const targetBlocks = isTopsBlock ? block.below(2) : isTopBlock ? block.above() : block.above(2);
      if (targetBlocks.typeId === targetId) {
        targetBlocks.setType('minecraft:air');
      }
      const baratDir = barat.permutation.getState('minecraft:cardinal_direction');
      const timurDir = timur.permutation.getState('minecraft:cardinal_direction');
      const utaraDir = utara.permutation.getState('minecraft:cardinal_direction');
      const selatanDir = selatan.permutation.getState('minecraft:cardinal_direction');
      const sideIsMirror = baratDir === 'south' ? barat.permutation.getState('md:mirror') : timurDir === 'north' ? timur.permutation.getState('md:mirror') : utaraDir === 'west' ? utara.permutation.getState('md:mirror') : selatan.permutation.getState('md:mirror');
      if ((baratDir === 'south' || timurDir === 'north' || utaraDir === 'west' || selatanDir === 'east') && sideIsMirror) {
        const sideBlock = baratDir === 'south' ? barat : timurDir === 'north' ? timur : utaraDir === 'west' ? utara : selatan;
        sideBlock.setPermutation(sideBlock.permutation.withState('md:mirror', false));
        const targetSide = (isTopBlock || isTopsBlock) ? sideBlock.below() : sideBlock.above();
        targetSide.setPermutation(targetSide.permutation.withState('md:mirror', false));
        const targetsSide = isTopsBlock ? sideBlock.below(2) : isTopBlock ? sideBlock.above() : sideBlock.above(2);
        if (targetsSide.typeId === targetId) {
          targetsSide.setPermutation(targetsSide.permutation.withState('md:mirror', false));
        }
      }
    }
  });
  mono.blockComponentRegistry.registerCustomComponent('md:door_interact', {
    onPlayerInteract(e) {
      const { block, player } = e;
      const equipment = player.getComponent('equippable');
      const selectedItem = equipment.getEquipment('Mainhand');
      const direction = block.permutation.getState('minecraft:cardinal_direction');
      const selatan = block.south();
      const utara = block.north();
      const barat = block.west();
      const timur = block.east();
      const bawah = block.below();
      const isMirror = block.permutation.getState('md:mirror');
      const isOpen = block.permutation.getState('md:is_open');
      const isTop = bawah.permutation.getState('md:door_type') == 'bottom' || bawah.permutation.getState('md:door_type') == 'bottom_2';
      const isTops = bawah.permutation.getState('md:door_type') == 'middle';
      const isMiddle = block.permutation.getState('md:door_type') == 'middle';
      const atas = block.above();
      const atasMiddle = atas.permutation.getState('md:door_type') == 'middle';
      const isBottom = block.permutation.getState('md:door_type') == 'bottom' || block.permutation.getState('md:door_type') == 'bottom_2';
      const tipe = block.typeId;
      const targetBlock = isTop ? block.above() : block.above(2);
      const blockTopSide = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? targetBlock.north() : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? targetBlock.south() : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? targetBlock.east() : targetBlock.west();
      const sameBlock = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.typeId === tipe : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.typeId === tipe : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.typeId === tipe : barat.typeId === tipe;
      const getDir = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.permutation.getState('minecraft:cardinal_direction') : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.permutation.getState('minecraft:cardinal_direction') : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.permutation.getState('minecraft:cardinal_direction') : barat.permutation.getState('minecraft:cardinal_direction');
      const sideIsMirror = direction === 'west' ? utara.permutation.getState('md:mirror') : direction === 'east' ? selatan.permutation.getState('md:mirror') : direction === 'north' ? timur.permutation.getState('md:mirror') : barat.permutation.getState('md:mirror');
      const targetDoor = (isTops || isTop) ? block.below() : block.above();
      const targetDoors = isTops ? block.below(2) : isTop ? block.above() : block.above(2);
      if (block.hasTag('door_slide')) {
        block.setPermutation(block.permutation.withState('md:open', isOpen ? 3 : 1));
        block.setPermutation(block.permutation.withState('md:tick', true));
        targetDoor.setPermutation(targetDoor.permutation.withState('md:open', isOpen ? 3 : 1));
        targetDoor.setPermutation(targetDoor.permutation.withState('md:tick', true));
        if (targetDoors.typeId === tipe) {
          targetDoors.setPermutation(targetDoors.permutation.withState('md:open', isOpen ? 3 : 1));
          targetDoors.setPermutation(targetDoors.permutation.withState('md:tick', true));
        }
      }
      if (!block.hasTag('door_slide')) {
        block.setPermutation(block.permutation.withState('md:is_open', isOpen ? false : true));
        targetDoor.setPermutation(targetDoor.permutation.withState('md:is_open', isOpen ? false : true));
        if (targetDoors.typeId === tipe) {
          targetDoors.setPermutation(targetDoors.permutation.withState('md:is_open', isOpen ? false : true));
        }
      }
      const sideDir = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.permutation.getState('minecraft:cardinal_direction') : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.permutation.getState('minecraft:cardinal_direction') : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.permutation.getState('minecraft:cardinal_direction') : barat.permutation.getState('minecraft:cardinal_direction');
      if (direction === sideDir && (sideIsMirror || isMirror)) {
        const sideTarget = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur : barat;
        const sideTargets = (isTops || isTop) ? sideTarget.below() : sideTarget.above();
        const sidesTargets = isTops ? sideTarget.below(2) : isTop ? sideTarget.above() : sideTarget.above(2);
        if (block.hasTag('door_slide')) {
          sideTarget.setPermutation(sideTarget.permutation.withState('md:open', isOpen ? 3 : 1));
          sideTarget.setPermutation(sideTarget.permutation.withState('md:tick', true));
          sideTargets.setPermutation(sideTargets.permutation.withState('md:open', isOpen ? 3 : 1));
          sideTargets.setPermutation(sideTargets.permutation.withState('md:tick', true));
          if (sidesTargets.typeId === tipe) {
            sidesTargets.setPermutation(sidesTargets.permutation.withState('md:open', isOpen ? 3 : 1));
            sidesTargets.setPermutation(sidesTargets.permutation.withState('md:tick', true));
          }
        }
        if (!block.hasTag('door_slide')) {
          sideTarget.setPermutation(sideTarget.permutation.withState('md:is_open', isOpen ? false : true));
          sideTargets.setPermutation(sideTargets.permutation.withState('md:is_open', isOpen ? false : true));
          if (sidesTargets.typeId === tipe) {
            sidesTargets.setPermutation(sidesTargets.permutation.withState('md:is_open', isOpen ? false : true));
          }
        }
      }
      const sound = isOpen ? "close_door.copper" : "open_door.copper";
      const soundWood = isOpen ? "close.wooden_door" : "open.wooden_door";
      const sounds = block.hasTag('wooden_door') ? soundWood : sound;
      block.dimension.playSound(sounds, block.location);
    }
  });
  mono.blockComponentRegistry.registerCustomComponent('md:door_slide_tick', {
    onTick(e) {
      const { block } = e;
      const opens = block.permutation.getState('md:open');
      const isOpen = block.permutation.getState('md:is_open');
      block.setPermutation(block.permutation.withState('md:open', isOpen ? opens - 1 : opens + 1));
      const open = block.permutation.getState('md:open');
      if (open === 0 || open === 4) {
        block.setPermutation(block.permutation.withState('md:is_open', isOpen ? false : true));
        block.setPermutation(block.permutation.withState('md:tick', false));
      }
    }
  });
});
world.beforeEvents.itemUseOn.subscribe(mono => {
  const { source, block, itemStack } = mono;
  const player = source;
  if (itemStack.typeId != 'md:md_tool' || !player.isSneaking) return;
  mono.cancel = true;
  changeDoor(player, block);
});
function changeDoor(player, block) {
  system.run(() => {
    const isDoor = block.permutation.getState('md:door_type');
    if (isDoor == undefined) return;
    const direction = block.permutation.getState('minecraft:cardinal_direction');
    const selatan = block.south();
    const utara = block.north();
    const barat = block.west();
    const timur = block.east();
    const bawah = block.below();
    const isMirror = block.permutation.getState('md:mirror');
    const isOpen = block.permutation.getState('md:is_open');
    const isTop = bawah.permutation.getState('md:door_type') == 'bottom' || bawah.permutation.getState('md:door_type') == 'bottom_2';
    const isTops = bawah.permutation.getState('md:door_type') == 'middle';
    const isMiddle = block.permutation.getState('md:door_type') == 'middle';
    const atas = block.above();
    const atasMiddle = atas.permutation.getState('md:door_type') == 'middle';
    const isBottom = block.permutation.getState('md:door_type') == 'bottom' || block.permutation.getState('md:door_type') == 'bottom_2';
    const tipe = block.typeId;
    if (isTops || isMiddle || (isBottom && atasMiddle)) {
      const targetTops = isTops ? block : isMiddle ? block.above() : block.above(2);
      const targetMid = isTops ? block.below() : isMiddle ? block : block.above();
      const targetBottom = isTops ? block.below(2) : isMiddle ? block.below() : block;
      targetTops.setType('minecraft:air');
      targetMid.setPermutation(targetMid.permutation.withState('md:door_type', 'top'));
      targetBottom.setPermutation(targetBottom.permutation.withState('md:door_type', 'bottom'));
      block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${targetTops.location.x} ${targetTops.location.y} ${targetTops.location.z}`);
      const sideDir = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.permutation.getState('minecraft:cardinal_direction') : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.permutation.getState('minecraft:cardinal_direction') : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.permutation.getState('minecraft:cardinal_direction') : barat.permutation.getState('minecraft:cardinal_direction');
      const sideIsMirror = direction === 'west' ? utara.permutation.getState('md:mirror') : direction === 'east' ? selatan.permutation.getState('md:mirror') : direction === 'north' ? timur.permutation.getState('md:mirror') : barat.permutation.getState('md:mirror');
      if (direction === sideDir && (sideIsMirror || isMirror)) {
        const sideBlock = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur : barat;
        const sideBlocks = isTops ? sideBlock : isTop ? sideBlock.above() : sideBlock.above(2);
        const sidesBlocks = isTops ? sideBlock.below() : isTop ? sideBlock : sideBlock.above();
        const bawahSideBlocks = isTops ? sideBlock.below(2) : isTop ? sideBlock.below() : sideBlock;
        sideBlocks.setType('minecraft:air');
        block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${sideBlocks.location.x} ${sideBlocks.location.y} ${sideBlocks.location.z}`);
        sidesBlocks.setPermutation(sidesBlocks.permutation.withState('md:door_type', 'top'));
        bawahSideBlocks.setPermutation(bawahSideBlocks.permutation.withState('md:door_type', 'bottom'));
      }
      return;
    }
    const targetBlock = isTop ? block.above() : block.above(2);
    const blockTopSide = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? targetBlock.north() : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? targetBlock.south() : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? targetBlock.east() : targetBlock.west();
    const sameBlock = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.typeId === tipe : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.typeId === tipe : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.typeId === tipe : barat.typeId === tipe;
    const getDir = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.permutation.getState('minecraft:cardinal_direction') : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.permutation.getState('minecraft:cardinal_direction') : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.permutation.getState('minecraft:cardinal_direction') : barat.permutation.getState('minecraft:cardinal_direction');
    const sideIsMirror = direction === 'west' ? utara.permutation.getState('md:mirror') : direction === 'east' ? selatan.permutation.getState('md:mirror') : direction === 'north' ? timur.permutation.getState('md:mirror') : barat.permutation.getState('md:mirror');
    if (((((targetBlock.isAir && !sideIsMirror) || (sameBlock && direction === getDir && blockTopSide.isAir && targetBlock.isAir)) && !isMirror) || (blockTopSide.isAir && targetBlock.isAir && isMirror))) {
      const triggerBlock = isTop ? block : block.above();
      const bawahBlock = isTop ? block.below() : block;
      targetBlock.setType(tipe);
      targetBlock.setPermutation(targetBlock.permutation.withState('minecraft:cardinal_direction', direction));
      targetBlock.setPermutation(targetBlock.permutation.withState('md:is_open', isOpen));
      triggerBlock.setPermutation(triggerBlock.permutation.withState('md:door_type', 'middle'));
      bawahBlock.setPermutation(bawahBlock.permutation.withState('md:door_type', 'bottom_2'));
      block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${targetBlock.location.x} ${targetBlock.location.y + 0.5} ${targetBlock.location.z}`);
      if (block.hasTag('door_slide')) {
        targetBlock.setPermutation(targetBlock.permutation.withState('md:open', isOpen ? 4 : 0));
      }
      const sideDir = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara.permutation.getState('minecraft:cardinal_direction') : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan.permutation.getState('minecraft:cardinal_direction') : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur.permutation.getState('minecraft:cardinal_direction') : barat.permutation.getState('minecraft:cardinal_direction');
      if (direction === sideDir && (sideIsMirror || isMirror)) {
        blockTopSide.setType(tipe);
        blockTopSide.setPermutation(blockTopSide.permutation.withState('minecraft:cardinal_direction', direction));
        blockTopSide.setPermutation(blockTopSide.permutation.withState('md:is_open', isOpen));
        if (block.hasTag('door_slide')) {
          blockTopSide.setPermutation(blockTopSide.permutation.withState('md:open', isOpen ? 4 : 0));
        }
        const triggerSide = ((direction === 'west' && !isMirror) || (direction === 'east' && isMirror)) ? utara : ((direction === 'east' && !isMirror) || (direction === 'west' && isMirror)) ? selatan : ((direction === 'north' && !isMirror) || (direction === 'south' && isMirror)) ? timur : barat;
        const triggerBlockSide = isTop ? triggerSide : triggerSide.above();
        const bawahBlockSide = isTop ? triggerSide.below() : triggerSide;
        block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${blockTopSide.location.x} ${blockTopSide.location.y} ${blockTopSide.location.z}`);
        triggerBlockSide.setPermutation(triggerBlockSide.permutation.withState('md:door_type', 'middle'));
        bawahBlockSide.setPermutation(bawahBlockSide.permutation.withState('md:door_type', 'bottom_2'));
      }
    }
  });
}