import { world, system } from '@minecraft/server';

function Sit(p) {
  if (p.hasComponent('riding')) {
    const ride = p.getComponent('riding').entityRidingOn;
    return ride.getComponent('rideable').ejectRider(p);
  }
  const isLay = p.getProperty('md:sleep');
  if (isLay) {
    p.setProperty('md:sleep', false);
    p.inputPermissions.movementEnabled = true;
  }
  const sit = p.dimension.spawnEntity('md:sit', p.location);
  sit.setRotation(p.getRotation());
  sit.getComponent('rideable').addRider(p);
}

function Lay(p, val) {
  if (p.isSneaking) return p.sendMessage('You should not sneaking');
  if (p.hasComponent('riding')) {
    const ride = p.getComponent('riding').entityRidingOn;
    ride.getComponent('rideable').ejectRider(p);
  }
  p.setProperty('md:sleep', val ? false : true);
  p.inputPermissions.movementEnabled = val ? true : false;
  p.sendMessage(val ? 'Lay nonaktif' : 'Lay aktif');
  if (val) return;
  const rotation = p.getRotation().y;
  const direction = rotation < -135 || rotation > 135 ? 'selatan' : rotation < 45 && rotation > -45 ? 'utara' : rotation > 45 && rotation < 135 ? 'barat' : 'timur';
  p.setProperty('md:sleep_rot', direction);
}

function Bocil(p, val) {
  p.triggerEvent('bocil');
  p.setProperty('md:size', val ? 2 : 3);
  p.sendMessage(val ? 'Bocil nonaktif' : 'Bocil aktif');
}

function Ride(p, val) {
  p.triggerEvent('ride');
  p.setProperty('md:ride', val ? false : true);
  p.sendMessage(val ? 'Ride nonaktif' : 'Ride aktif');  
}

function Clear(p) {
  const inventory = p.getComponent('inventory').container;
  for (let slot = 0; slot < inventory.size; slot++) {
    const item = inventory.getItem(slot);
    if (item && item.typeId.split(':')[1] != 'monophone') inventory.setItem(slot);
  }
  p.sendMessage('Inventory Cleared');
}

export { Sit, Lay, Bocil, Ride, Clear };