import { world, BlockPermutation  } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:horizontal_countertop_connected', {
        onPlace(e) {
            const { block } = e;
            const utara = block.north();
            const selatan = block.south();
            const barat = block.west();
            const timur = block.east();
            const tags = block.getTags();

            if (utara.hasTag(`${tags}`)) {
                utara.setPermutation(utara.permutation.withState('md:south_neighbor', 1));
                block.setPermutation(block.permutation.withState('md:north_neighbor', 1));
            }
            if (selatan.hasTag(`${tags}`)) {
                selatan.setPermutation(selatan.permutation.withState('md:north_neighbor', 1));
                block.setPermutation(block.permutation.withState('md:south_neighbor', 1));
            }
            if (barat.hasTag(`${tags}`)) {
                barat.setPermutation(barat.permutation.withState('md:east_neighbor', 1));
                block.setPermutation(block.permutation.withState('md:west_neighbor', 1));
            }
            if (timur.hasTag(`${tags}`)) {
                timur.setPermutation(timur.permutation.withState('md:west_neighbor', 1));
                block.setPermutation(block.permutation.withState('md:east_neighbor', 1));
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:horizontal_countertop_destroy', {
        onPlayerDestroy(e) {
            const { block } = e;
            const utara = block.north();
            const selatan = block.south();
            const barat = block.west();
            const timur = block.east();

             if (utara) {
                const stateUtara = utara.permutation.getState('md:south_neighbor');
                if (stateUtara) {
                    utara.setPermutation(utara.permutation.withState('md:south_neighbor', 0));
                }
            }

            if (selatan) {
                const stateSelatan = selatan.permutation.getState('md:north_neighbor');
                if (stateSelatan) {
                    selatan.setPermutation(selatan.permutation.withState('md:north_neighbor', 0));
                }
            }

            if (barat) {
                const stateBarat = barat.permutation.getState('md:east_neighbor');
                if (stateBarat) {
                    barat.setPermutation(barat.permutation.withState('md:east_neighbor', 0));
                }
            }

            if (timur) {
                const stateTimur = timur.permutation.getState('md:west_neighbor');
                if (stateTimur) {
                    timur.setPermutation(timur.permutation.withState('md:west_neighbor', 0));
                }
            }
        }
    });
});