import { world } from '@minecraft/server';

// Fungsi untuk memainkan suara klik
function playClickSound(block) {
    block.dimension.playSound("random.click", block.location);
}

world.beforeEvents.worldInitialize.subscribe(eventData => {
    // Komponen untuk 'md:interactive_1'
    eventData.blockComponentRegistry.registerCustomComponent('md:interactive_1', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('md:channel') ?? 0; // Gunakan 0 jika state undefined

            if (currentState < 4) {
                block.setPermutation(permutation.withState('md:channel', currentState + 1));
            } else if (currentState === 4) {
                block.setPermutation(permutation.withState('md:channel', 0));
            }

            playClickSound(block); // Panggil fungsi suara
        }
    });

    // Komponen untuk 'md:interactive_0'
    eventData.blockComponentRegistry.registerCustomComponent('md:interactive_0', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('md:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            block.setPermutation(permutation.withState('md:on', newOpenState)); // Ubah permutasi dengan state baru
            playClickSound(block); // Panggil fungsi suara
        }
    });
});
