import { world } from '@minecraft/server';
world.beforeEvents.worldInitialize.subscribe(mono => {
    mono.blockComponentRegistry.registerCustomComponent('md:sit', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const In = block.permutation.getState('md:in');          
            if ((In == false || In) && player.isSneaking) {
               return block.setPermutation(block.permutation.withState('md:in', In ? false : true));               
            }
            if (In) return;
            const isLay = player.getProperty('md:sleep');
            if (isLay) {
              player.setProperty('md:sleep', false);
              player.inputPermissions.movementEnabled = true;
            }
            const { x, y, z } = block.center();
            const entity = block.dimension.spawnEntity('md:sit', { x, y: y + 0.1, z });
            const direction = block.permutation.getState("minecraft:cardinal_direction");
            entity.getComponent('rideable').addRider(player);
            switch (direction) {
                case 'north':
                    entity.teleport(entity.location, { facingLocation: { x, y, z: z + 1 } });
                    break;
                case 'east':
                    entity.teleport(entity.location, { facingLocation: { x: x - 1, y, z } });
                    break;
                case 'south':
                    entity.teleport(entity.location, { facingLocation: { x, y, z: z - 1 } });
                    break;
                case 'west':
                    entity.teleport(entity.location, { facingLocation: { x: x + 1, y, z } });
                    break;
                default: break;
            }
        }
    });
});