import { world } from '@minecraft/server';
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:vertical_connected', {
        onPlace(e) {
            const { block } = e;
            const topState = block.above();
            const bottomState = block.below();
            const tags = block.getTags();

            const hasTag = (blockState, tagName) => blockState.hasTag(tagName);

            tags.forEach(tag => {
                if (hasTag(topState, tag)) {
                    topState.setPermutation(topState.permutation.withState('md:bottom', 1));
                    block.setPermutation(block.permutation.withState('md:top', 1));
                }
                if (hasTag(bottomState, tag)) {
                    bottomState.setPermutation(bottomState.permutation.withState('md:top', 1));
                    block.setPermutation(block.permutation.withState('md:bottom', 1));
                }
            });
        }
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:vertical_destroy', {
        onPlayerDestroy(e) {
            const { block } = e;
            const topState = block.above();
            const bottomState = block.below();

            // Pengecekan jika topState dan bottomState ada
            if (topState) {
                const stateAbove = topState.permutation.getState('md:bottom');
                if (stateAbove) {
                    topState.setPermutation(topState.permutation.withState('md:bottom', 0));
                }
            }

            if (bottomState) {
                const stateBelow = bottomState.permutation.getState('md:top');
                if (stateBelow) {
                    bottomState.setPermutation(bottomState.permutation.withState('md:top', 0));
                }
            }
        }
    });
});
