import { world } from '@minecraft/server';
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:vertical_full_connected', {
        onPlace(e) {
            const { block } = e;
            const utara = block.north();
            const selatan = block.south();
            const barat = block.west();
            const timur = block.east();
            const topState = block.above();
            const bottomState = block.below();
            const tags = block.getTags();

            const hasTag = (blockState, tagName) => blockState.hasTag(tagName);

            tags.forEach(tag => {
                if (hasTag(utara, tag)) {
                    utara.setPermutation(utara.permutation.withState('md:south_neighbor', 1))
                    block.setPermutation(block.permutation.withState('md:north_neighbor', 1))
                }
                if (hasTag(selatan, tag)) {
                    selatan.setPermutation(selatan.permutation.withState('md:north_neighbor', 1))
                    block.setPermutation(block.permutation.withState('md:south_neighbor', 1))
                }
                if (hasTag(barat, tag)) {
                    barat.setPermutation(barat.permutation.withState('md:east_neighbor', 1))
                    block.setPermutation(block.permutation.withState('md:west_neighbor', 1))
                }
                if (hasTag(timur, tag)) {
                    timur.setPermutation(timur.permutation.withState('md:west_neighbor', 1))
                    block.setPermutation(block.permutation.withState('md:east_neighbor', 1))
                }
                if (hasTag(topState, tag)) {
                    topState.setPermutation(topState.permutation.withState('md:bottom', 1))
                    block.setPermutation(block.permutation.withState('md:top', 1))
                }
                if (hasTag(bottomState, tag)) {
                    bottomState.setPermutation(bottomState.permutation.withState('md:top', 1))
                    block.setPermutation(block.permutation.withState('md:bottom', 1))
                }

            })
        }
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:vertical_full_destroy', {
        onPlayerDestroy(e) {
            const { block } = e;
            const utara = block.north();
            const selatan = block.south();
            const barat = block.west();
            const timur = block.east();
            const topState = block.above();
            const bottomState = block.below();

            // Pengecekan state pada neighbors
            if (utara) {
                const stateUtara = utara.permutation.getState('md:south_neighbor');
                if (stateUtara) {
                    utara.setPermutation(utara.permutation.withState('md:south_neighbor', 0));
                }
            }

            if (selatan) {
                const stateSelatan = selatan.permutation.getState('md:north_neighbor');
                if (stateSelatan) {
                    selatan.setPermutation(selatan.permutation.withState('md:north_neighbor', 0));
                }
            }

            if (barat) {
                const stateBarat = barat.permutation.getState('md:east_neighbor');
                if (stateBarat) {
                    barat.setPermutation(barat.permutation.withState('md:east_neighbor', 0));
                }
            }

            if (timur) {
                const stateTimur = timur.permutation.getState('md:west_neighbor');
                if (stateTimur) {
                    timur.setPermutation(timur.permutation.withState('md:west_neighbor', 0));
                }
            }

            if (topState) {
                const stateAbove = topState.permutation.getState('md:bottom');
                if (stateAbove) {
                    topState.setPermutation(topState.permutation.withState('md:bottom', 0));
                }
            }

            if (bottomState) {
                const stateBelow = bottomState.permutation.getState('md:top');
                if (stateBelow) {
                    bottomState.setPermutation(bottomState.permutation.withState('md:top', 0));
                }
            }
        }
    });
});